---------------------------------------------------------
-- I Am Groot
-- Create Date: 9/14/2018
-- Version 1.0
---------------------------------------------------------

local Ir = {"I", "i"}
local Ar = {"A", "a"}
local Mr = {"M", "m"}
local Gr = {"G", "g"}
local Rr = {"R", "r"}
local Or = {"O", "o"}
local Ori = {"O", "o"}
local Tr = {"T", "t"}
local icolor = {"C41F3B", "A330C9", "FF7D0A", "ABD473", "40C7EB", "00FF96", "F58CBA", "FFFFFF", "FFF569", "0070DE", "8787ED", "C79C6E"}

local f = CreateFrame("frame")
local size = 30

local function eventhandler(self,event)
	DEFAULT_CHAT_FRAME:AddMessage("I Am Groot Loaded.");
end

f:SetScript("OnEvent",eventhandler);

local btn = CreateFrame("Button", "IAmGrootBtn", UIParent, "SecureActionButtonTemplate")
btn:SetPoint("CENTER")
btn:SetHeight(size)
btn:SetWidth(size)
btn:SetAttribute("type", "item")
local icon = btn:CreateTexture()
icon:SetAllPoints(true)
icon:SetTexture("Interface\\Icons\\Spell_nature_naturesblessing")

btn.icon = icon
btn:EnableMouse(true)
btn:SetMovable(true)
btn:RegisterForDrag("LeftButton")
btn:SetScript("OnDragStart", function(self) if IsAltKeyDown() then self:StartMoving() end end)
btn:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

btn:SetScript("OnClick", function(event)
	--print("click")
	groot();
end)

btn:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self,"ANCHOR_TOP")
		GameTooltip:AddLine("I Am Groot")
		GameTooltip:AddLine("Alt+Drag to move")
	GameTooltip:Show()
end)

btn:SetScript("OnLeave", function() GameTooltip:Hide() end)

function groot()
	msg = ( 
	Ir[math.random(1, #Ir)] .. " " ..
	Ar[math.random(1, #Ar)] .. 
	Mr[math.random(1, #Mr)] .. " " ..
	Gr[math.random(1, #Gr)] .. 
	Rr[math.random(1, #Rr)] .. 
	Or[math.random(1, #Or)] .. 
	Ori[math.random(1, #Ori)] .. 
	Tr[math.random(1, #Tr)]
	)
	SendChatMessage((msg) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
end

function grootcolor() -- Work in Progress
	msg1 = string( 
	"|cff" .. icolor[math.random(1, #icolor)] .. Ir[math.random(1, #Ir)] .. "|r" .. 
	"|cff" .. icolor[math.random(1, #icolor)] .. Ar[math.random(1, #Ar)] .. "|r" ..	
	"|cff" .. icolor[math.random(1, #icolor)] .. Mr[math.random(1, #Mr)] .. "|r" ..	
	"|cff" .. icolor[math.random(1, #icolor)] .. Gr[math.random(1, #Gr)] .. "|r" ..	
	"|cff" .. icolor[math.random(1, #icolor)] .. Rr[math.random(1, #Rr)] .. "|r" ..	
	"|cff" .. icolor[math.random(1, #icolor)] .. Or[math.random(1, #Or)] .. "|r" ..	
	"|cff" .. icolor[math.random(1, #icolor)] .. Ori[math.random(1, #Ori)] .. "|r" .. 
	"|cff" .. icolor[math.random(1, #icolor)] .. Tr[math.random(1, #Tr)] .. "|r"
	)
	
	SendChatMessage((msg1) ,IsInGroup(2) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or IsInGroup(1) and "PARTY" or "SAY")
end